Index: src/Fl_Help_Dialog.cxx
===================================================================
--- src/Fl_Help_Dialog.cxx	(revision 13010)
+++ src/Fl_Help_Dialog.cxx	(working copy)
@@ -149,13 +149,13 @@
   { window_ = new Fl_Double_Window(530, 385, "Help Dialog");
     window_->user_data((void*)(this));
     { Fl_Group* o = new Fl_Group(10, 10, 511, 25);
-      { back_ = new Fl_Button(10, 10, 25, 25, "@<-");
+      { back_ = new Fl_Button(10, 10, 25, 25, FL_LT_ARROW_TX);
         back_->tooltip("Show the previous help page.");
         back_->shortcut(0xff51);
         back_->labelcolor((Fl_Color)2);
         back_->callback((Fl_Callback*)cb_back_);
       } // Fl_Button* back_
-      { forward_ = new Fl_Button(45, 10, 25, 25, "@->");
+      { forward_ = new Fl_Button(45, 10, 25, 25, FL_RT_ARROW_TX);
         forward_->tooltip("Show the next help page.");
         forward_->shortcut(0xff53);
         forward_->labelcolor((Fl_Color)2);
@@ -176,7 +176,7 @@
       { Fl_Group* o = new Fl_Group(350, 10, 171, 25);
         o->box(FL_DOWN_BOX);
         o->color(FL_BACKGROUND2_COLOR);
-        { find_ = new Fl_Input(375, 12, 143, 21, "@search");
+        { find_ = new Fl_Input(375, 12, 143, 21, FL_SYM_SEARCH_TX);
           find_->tooltip("find text in document");
           find_->box(FL_FLAT_BOX);
           find_->labelsize(13);
Index: src/Fl_Input.cxx
===================================================================
--- src/Fl_Input.cxx	(revision 13010)
+++ src/Fl_Input.cxx	(working copy)
@@ -370,6 +370,7 @@
   unsigned int mods = Fl::event_state() & (FL_META|FL_CTRL|FL_ALT);
   unsigned int shift = Fl::event_state() & FL_SHIFT;
   unsigned int multiline = (input_type() == FL_MULTILINE_INPUT) ? 1 : 0;
+
   //
   // The following lists apps that support these keypresses.
   // Prefixes: '!' indicates NOT supported, '?' indicates un-verified.
@@ -460,6 +461,9 @@
   static Fl_Widget *dnd_save_focus = NULL;
   switch (event) {
     case FL_UNFOCUS:
+      // disable unicode input
+      unicode_input_active(0);
+
       if (Fl::screen_driver()->has_marked_text() && Fl::compose_state) {
 	this->mark( this->position() );
 	Fl::reset_marked_text();
@@ -489,6 +493,65 @@
       break;
       
     case FL_KEYBOARD:
+
+      // handle unicode input
+      if (unicode_input_active()) {
+        // get as uppercase
+        int uch=Fl::event_key();
+        uch=toupper(uch);
+        // check key if key range valid for hex char
+        if ((uch>='0' && uch<='9') || (uch>='A' && uch<='F')) {
+          // convert key to value
+          uch-='0';
+          if (uch > 9) {
+            uch-=('A'-'9')-1;
+          }
+          unicodeval_=(unicodeval_ * 16)+uch;
+          return 1;
+        }
+        else {
+          // end the input (don't allow chars < a space)
+          if (unicodeval_>=' ') {
+            // build string (not zero terminated)
+            char utext[MB_CUR_MAX];
+            int utextlen;
+            // check for single byte hybrid mode
+            if (unicode_single_byte() && unicodeval_<256) {
+              utext[0]=(unsigned char) unicodeval_;
+              utextlen=1;
+            }
+            else utextlen=wctomb(utext, unicodeval_);
+            // ensure no error code
+            if (utextlen>0) {
+              // make actual replacement of character
+              replace(position(), mark(), utext, utextlen);
+            }
+          }
+          // disable mode
+          unicode_input_active(0);
+          // eat key that ended input if space or enter
+          if (uch==' ' || uch==FL_Enter || uch==FL_KP_Enter) {
+            return 1;
+          }
+        }
+      }
+      else if (!readonly() && unicode_input()) {
+        // check if ctrl-shift down
+        if ((Fl::event_state() & (FL_CTRL|FL_SHIFT))==(FL_CTRL|FL_SHIFT)) {
+          // yes, check if u
+          int ch=Fl::event_key();
+          if (ch=='U' || ch=='u') {
+            // yes, but ignore if someone set on int/float types
+            if (input_type()!=FL_FLOAT_INPUT && input_type()!=FL_INT_INPUT) {
+              // reset value to build
+              unicodeval_=0;
+              unicode_input_active(1);
+              return 1;
+            }
+          }
+        }
+      }
+
       // Handle special case for multiline input with 'old tab behavior'
       // where tab is entered as a character: make sure user attempt to 'tab over'
       // widget doesn't destroy the field, replacing it with a tab character.
Index: src/Fl_Input_.cxx
===================================================================
--- src/Fl_Input_.cxx	(revision 13010)
+++ src/Fl_Input_.cxx	(working copy)
@@ -59,14 +59,14 @@
 //  const char *pe = p + strlen(p);
 
   if (input_type()==FL_SECRET_INPUT) {
-    while (o<e && p < value_+size_) {
-      if (fl_utf8len((char)p[0]) >= 1) {
+    const char *pend=value_ + size_;
+    while (o<e && p < pend) {
+      if (fl_utf8len_real(p, (int) (pend-p)) >= 1) {
 	l_secret = fl_utf8encode(Fl_Screen_Driver::secret_input_character, o);
 	o += l_secret;
       }
       p++;
     }
-
   } else while (o<e) {
     if (wrap() && (p >= value_+size_ || isspace(*p & 255))) {
       word_wrap = w() - Fl::box_dw(box()) - 2;
@@ -98,6 +98,10 @@
     }
   }
   *o = 0;
+  // truncate to user requested maximum size
+  if (maximum_size_<MAXBUF) {
+    buf[maximum_size_]=0;
+  }
   return p;
 }
 
@@ -123,7 +127,7 @@
   int l;
   if (input_type()==FL_SECRET_INPUT) {
     while (p<e) {
-      l = fl_utf8len((char)p[0]);
+      l = fl_utf8len_real(p, (int) (e-p));
       if (l >= 1) n += l_secret;
       p += l;
     }
@@ -137,7 +141,7 @@
     } else {
       n++;
     }
-    chr += fl_utf8len((char)p[0]) >= 1;
+    chr += fl_utf8len_real(p, (int) (e-p)) >= 1;
     p++;
   }
   if (returnn) *returnn = n;
@@ -376,8 +380,13 @@
 	        (int)(xpos+curx+0.5f), Y+ypos+height-4,
 	        (int)(xpos+curx+3.5f), Y+ypos+height-1);
       } else {
+        if (unicode_input_active()) {
+          fl_rectf((int)(xpos+curx+0.5), (Y+ypos)+(height/3), 2, height/2);
+        }
+        else {
         fl_rectf((int)(xpos+curx+0.5), Y+ypos, 2, height);
       }
+      }
       Fl::insertion_point_location((int)xpos+curx, Y+ypos+height, height);
     }
 
@@ -548,7 +557,7 @@
   const char *l, *r, *t; double f0 = Fl::event_x()-X+xscroll_;
   for (l = p, r = e; l<r; ) {
     double f;
-    int cw = fl_utf8len((char)l[0]);
+    int cw = fl_utf8len_real(l, (int) (r-l));
     if (cw < 1) cw = 1;
     t = l+cw;
     f = X-xscroll_+expandpos(p, t, buf, 0);
@@ -557,7 +566,7 @@
   }
   if (l < e) { // see if closer to character on right:
     double f1;
-    int cw = fl_utf8len((char)l[0]);
+    int cw = fl_utf8len_real(l, (int) (e - l));
     if (cw > 0) {
       f1 = X-xscroll_+expandpos(p, l + cw, buf, 0) - Fl::event_x();
       if (f1 < f0) l = l+cw;
@@ -601,6 +610,50 @@
 }
 
 /**
+  Helper for position(int p, int m)
+
+  Adjust the to the position /e p aligned with utf8
+  chars based on the current_position.
+
+  \param p index for the desired cursor position
+  \param current_position the cursor current position
+  \return aligned position for p
+*/
+int Fl_Input_::position_adjust(int p, int current_position)
+{
+  // point to start character at p
+  const char *u8chr=value() + p;
+
+  u8chr = fl_utf8_find_leading_char(u8chr, value(), size());
+
+  // adjust to actual position of u8chr
+  int u8chrpos=(int) (u8chr - value());
+
+  // check direction
+  if (p > current_position) {
+    // forward
+    while (u8chrpos<size() && u8chrpos < p) {
+      // calc chr len
+      int u8chrlen = fl_utf8len_real(u8chr, size() - u8chrpos);
+      if (u8chrlen < 0) u8chrlen = 1;
+      // move to next char
+      u8chrpos += u8chrlen;
+      u8chr += u8chrlen;
+    }
+  }
+  else {
+    // reverse
+    while (u8chrpos>0 && u8chrpos > p) {
+      u8chr = fl_utf8_find_leading_char(u8chr - 1, value(), size());
+      u8chrpos = (int) (u8chr - value());
+    }
+  }
+  // return final position
+  return u8chrpos;
+}
+
+
+/**
   Sets the index for the cursor and mark.
 
   The input widget maintains two pointers into the string. The
@@ -618,8 +671,8 @@
   \see position(int), position(), mark(int)
 */
 int Fl_Input_::position(int p, int m) {
+  was_up_down = 0;
   int is_same = 0;
-  was_up_down = 0;
   if (p<0) p = 0;
   if (p>size()) p = size();
   if (m<0) m = 0;
@@ -626,26 +679,12 @@
   if (m>size()) m = size();
   if (p == m) is_same = 1;
 
-  while (p < position_ && p > 0 && (size() - p) > 0 &&
-       (fl_utf8len((char)(value() + p)[0]) < 1)) { p--; }
-  int ul = fl_utf8len((char)(value() + p)[0]);
-  while (p < size() && p > position_ && ul < 0) {
-       p++;
-       ul = fl_utf8len((char)(value() + p)[0]);
-  }
+  p = position_adjust(p, position_);
+  m = position_adjust(m, mark_);
 
-  while (m < mark_ && m > 0 && (size() - m) > 0 &&
-       (fl_utf8len((char)(value() + m)[0]) < 1)) { m--; }
-  ul = fl_utf8len((char)(value() + m)[0]);
-  while (m < size() && m > mark_ && ul < 0) {
-       m++;
-       ul = fl_utf8len((char)(value() + m)[0]);
-  }
   if (is_same) m = p;
   if (p == position_ && m == mark_) return 0;
 
-
-  //if (Fl::selection_owner() == this) Fl::selection_owner(0);
   if (p != m) {
     if (p != position_) minimal_update(position_, p);
     if (m != mark_) minimal_update(mark_, m);
@@ -789,21 +828,22 @@
   invalid UTF-8 bytes as one character each).
 */
 int Fl_Input_::replace(int b, int e, const char* text, int ilen) {
-  int ul, om, op;
+  int om, op;
   was_up_down = 0;
-
+  int is_same = 0;
   if (b<0) b = 0;
   if (e<0) e = 0;
   if (b>size_) b = size_;
   if (e>size_) e = size_;
   if (e<b) {int t=b; b=e; e=t;}
-  while (b != e && b > 0 && (size_ - b) > 0 &&
-       (fl_utf8len((value_ + b)[0]) < 1)) { b--; }
-  ul = fl_utf8len((char)(value_ + e)[0]);
-  while (e < size_ && e > 0 && ul < 0) {
-       e++;
-       ul = fl_utf8len((char)(value_ + e)[0]);
+  if (e==b) is_same = 1;
+
+  b = position_adjust(b, e);
+  if (is_same) {
+      e = b;
   }
+  else e = position_adjust(e, b);
+
   if (text && !ilen) ilen = (int) strlen(text);
   if (e<=b && !ilen) return 0; // don't clobber undo for a null operation
 
@@ -812,12 +852,13 @@
 
   int nchars = 0;	// characters in value() - deleted + inserted
   const char *p = value_;
-  while (p < (char *)(value_+size_)) {
+  const char *pend = value_ + size_;
+  while (p < pend) {
     if (p == (char *)(value_+b)) { // skip removed part
       p = (char *)(value_+e);
-      if (p >= (char *)(value_+size_)) break;
+      if (p >= pend) break;
     }
-    int ulen = fl_utf8len(*p);
+    int ulen = fl_utf8len_real(p, (int) (pend - p));
     if (ulen < 1) ulen = 1; // invalid UTF-8 character: count as 1
     nchars++;
     p += ulen;
@@ -824,10 +865,14 @@
   }
   int nlen = 0;		// length (in bytes) to be inserted
   p = text;
-  while (p < (char *)(text+ilen) && nchars < maximum_size()) {
-    int ulen = fl_utf8len(*p);
+  pend = text + ilen;
+  while (p < pend && nchars < maximum_size()) {
+    int ulen = fl_utf8len_real(p, (int) (pend - p));
     if (ulen < 1) ulen = 1; // invalid UTF-8 character: count as 1
     nchars++;
+    if (nchars > maximum_size()) {
+      break;
+    }
     p += ulen;
     nlen += ulen;
   }
@@ -1112,6 +1157,7 @@
 */
 Fl_Input_::Fl_Input_(int X, int Y, int W, int H, const char* l)
 : Fl_Widget(X, Y, W, H, l) {
+  flags_ex_ = 0;
   box(FL_DOWN_BOX);
   color(FL_BACKGROUND2_COLOR, FL_SELECTION_COLOR);
   align(FL_ALIGN_LEFT);
@@ -1170,8 +1216,13 @@
   }
   memmove(buffer, value_, size_); buffer[size_] = 0;
   value_ = buffer;
+  // limit to user provied max input
+  if (maximum_size_<size_) {
+    buffer[maximum_size_]=0;
 }
 
+}
+
 /**
   Changes the widget text.
 
@@ -1216,6 +1267,10 @@
     xscroll_ = yscroll_ = 0;
     minimal_update(0);
   }
+
+  if (size_>maximum_size_) {
+    size_=maximum_size_;
+  }
   position(readonly() ? 0 : size());
   return 1;
 }
Index: src/Fl_Input_Choice.cxx
===================================================================
--- src/Fl_Input_Choice.cxx	(revision 13010)
+++ src/Fl_Input_Choice.cxx	(working copy)
@@ -99,9 +99,30 @@
 Fl_Input_Choice::InputMenuButton::InputMenuButton(int x,int y,int w,int h,const char*l)
                                  :Fl_Menu_Button(x,y,w,h,l)
 {
+  flags_ex_=0;
   box(FL_UP_BOX);
 }
 
+/** Handle down arrow to open button */
+
+int Fl_Input_Choice::InputMenuButton::handle(int event)
+{
+  if (event==FL_FOCUS) {
+    // don't allow focus to button
+    return 0;
+  }
+
+  if (arrow_shortcut()) {
+    // captures all forms of down arrow to open menu.
+    if (event==FL_KEYBOARD && Fl::focus()==this && Fl::event_key()==FL_Down) {
+      popup();
+      return 1;
+    }
+  }
+
+  return Fl_Menu_Button::handle(event);
+}
+
 /** Draws the private menu button. */
 
 void Fl_Input_Choice::InputMenuButton::draw() {
@@ -175,8 +196,7 @@
 : Fl_Group(X,Y,W,H,L) {
   Fl_Group::box(FL_DOWN_BOX);
   align(FL_ALIGN_LEFT);					// default like Fl_Input
-  inp_ = new Fl_Input(inp_x(), inp_y(),
-                      inp_w(), inp_h());
+  inp_ = new InputSubclass(inp_x(), inp_y(),inp_w(), inp_h());
   inp_->callback(inp_cb, (void*)this);
   inp_->box(FL_FLAT_BOX);				// cosmetic
   inp_->when(FL_WHEN_CHANGED|FL_WHEN_NOT_CHANGED);
@@ -212,6 +232,24 @@
   // no need to call Fl_Widget::set_changed()
 }
 
+/** Handle down arrow to open button */
+
+int Fl_Input_Choice::handle(int event)
+{
+  // this captures Alt-Down arrow when input field has kb focus
+  // because a normal down arrow is already eaten by the Fl_Input
+  // object (receives handle first when it has focus).  If you want
+  // the down arrow to work too, you'd need to call
+  // enable_arrow_shortcut().
+  if (arrow_shortcut()) {
+    if (event==FL_KEYBOARD && Fl::focus()==inp_ && Fl::event_key()==FL_Down) {
+      menu_->popup();
+      return 1;
+    }
+  }
+  return Fl_Group::handle(event);
+}
+
 /** Clears the changed() state of both input and menu button widgets. */
 void Fl_Input_Choice::clear_changed() {
   inp_->clear_changed();
@@ -261,6 +299,33 @@
   return 0;		// not found
 }
 
+/** Constructor for private input widget . */
+
+Fl_Input_Choice::InputSubclass::InputSubclass(int X, int Y, int W, int H)
+               : Fl_Input(X, Y, W, H)
+{
+  flags_ex_=0;
+};
+
+/**
+  Handles events of Fl_Input_Choice embedded input widget.
+
+  Works like Fl_Input::handle() but ignores FL_Up and FL_Down keys
+  so they can be handled by the parent widget (Fl_Input_Choice).
+*/
+int Fl_Input_Choice::InputSubclass::handle(int event) {
+  if (event == FL_KEYBOARD) {
+    if (arrow_shortcut()) {
+      const int key = Fl::event_key();
+      if (key == FL_Down) {
+        return 0;
+      }
+    }
+  }
+  return Fl_Input::handle(event);
+}
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Menu_add.cxx
===================================================================
--- src/Fl_Menu_add.cxx	(revision 13010)
+++ src/Fl_Menu_add.cxx	(working copy)
@@ -153,7 +153,10 @@
   const char* item;
 
   // split at slashes to make submenus:
-  for (;;) {
+	if (myflags & FL_MENU_NO_SPLIT) {
+		item=mytext;
+	}
+  else for (;;) {
 
     // leading slash makes us assume it is a filename:
     if (*mytext == '/') {item = mytext; break;}
Index: src/fl_shortcut.cxx
===================================================================
--- src/fl_shortcut.cxx	(revision 13010)
+++ src/fl_shortcut.cxx	(working copy)
@@ -71,6 +71,11 @@
   // if shift is also correct, check for exactly equal keysyms:
   if (!(mismatch&(FL_SHIFT)) && key == (unsigned)Fl::event_key()) return 1;
 
+  // test new logic where keypad enter is same as enter
+  if (key==FL_Enter && new_shortcut_logic) {
+    if (!(mismatch&(FL_SHIFT)) && FL_KP_Enter == (unsigned)Fl::event_key()) return 1;
+  }
+
   // try matching utf8, ignore shift:
   unsigned int firstChar = fl_utf8decode(Fl::event_text(), Fl::event_text()+Fl::event_length(), 0);
   if ( ! (FL_CAPS_LOCK&shift) && key==firstChar) return 1;
Index: src/Fl_Spinner.cxx
===================================================================
--- src/Fl_Spinner.cxx	(revision 13010)
+++ src/Fl_Spinner.cxx	(working copy)
@@ -39,7 +39,10 @@
     v = atof(sb->input_.value());
 
     if (v < sb->minimum_) {
-      sb->value_ = sb->minimum_;
+      if (v==0 && sb->blank_allowed()) {
+        sb->value_=0;
+      }
+      else sb->value_ = sb->minimum_;
       sb->update();
     } else if (v > sb->maximum_) {
       sb->value_ = sb->maximum_;
@@ -48,24 +51,31 @@
   } else if (w == &(sb->up_button_)) {
     // Up button pressed...
     v = sb->value_ + sb->step_;
-    if (v > sb->maximum_) {
-      if (sb->wrap_)
-	v = sb->minimum_;
-      else
-	v = sb->maximum_;
+
+    // catch up arrow starting at zero/blank
+    if (v < sb->minimum_ && sb->blank_allowed()) {
+      sb->value_ = sb->minimum_;
     }
-    sb->value_ = v;
+    else if (v > sb->maximum_) {
+      if (sb->minimum_>0 && sb->blank_allowed()) {
+        sb->value_=0;
+      }
+      else sb->value_ = sb->minimum_;
+    }
+    else sb->value_ = v;
+
     sb->update();
   } else if (w == &(sb->down_button_)) {
     // Down button pressed...
     v = sb->value_ - sb->step_;
     if (v < sb->minimum_) {
-      if (sb->wrap_)
-	v = sb->maximum_;
-      else
-	v = sb->minimum_;
+      if (v>0 && sb->blank_allowed()) {
+        sb->value_=0;
     }
-    sb->value_ = v;
+      else sb->value_ = sb->maximum_;
+    }
+    else sb->value_ = v;
+
     sb->update();
   }
 
@@ -93,8 +103,6 @@
   input_.value(s);
 }
 
-#define FL_UP_ARROW_TX "@-42<"
-#define FL_DOWN_ARROW_TX "@-42>"
 
 /**
   Creates a new Fl_Spinner widget using the given position, size,
@@ -108,10 +116,12 @@
   input_(X, Y, W - H / 2 - 2, H),
   up_button_(X + W - H / 2 - 2, Y, H / 2 + 2, H / 2, FL_UP_ARROW_TX),
   down_button_(X + W - H / 2 - 2, Y + H - H / 2,
-               H / 2 + 2, H / 2, FL_DOWN_ARROW_TX)
+               H / 2 + 2, H / 2, FL_DN_ARROW_TX)
 {
   end();
 
+  flags_ex_=0;
+
   value_   = 1.0;
   minimum_ = 1.0;
   maximum_ = 100.0;
@@ -123,7 +133,7 @@
 
   input_.value("1");
   input_.type(FL_INT_INPUT);
-  input_.when(FL_WHEN_ENTER_KEY | FL_WHEN_RELEASE);
+  input_.when(/*FL_WHEN_ENTER_KEY | */FL_WHEN_RELEASE);
   input_.callback((Fl_Callback *)sb_cb, this);
 
   up_button_.callback((Fl_Callback *)sb_cb, this);
Index: src/fl_symbols.cxx
===================================================================
--- src/fl_symbols.cxx	(revision 13010)
+++ src/fl_symbols.cxx	(working copy)
@@ -17,7 +17,7 @@
 //
 
 // These are small graphics drawn by the normal label-drawing
-// code when the string starts with an '@' sign.
+// code when the string starts with an FL_SYMBOL_CHAR sign.
 
 // Adapted from original code written by:
 
@@ -70,7 +70,7 @@
 
 /**
   Adds a symbol to the system.
-  \param[in] name     name of symbol (without the "@")
+  \param[in] name     name of symbol (without the FL_SYMBOL_CHAR)
   \param[in] drawit   function to draw symbol
   \param[in] scalable set to 1 if \p drawit uses scalable vector drawing
   \returns 1 on success, 0 on failure
@@ -102,7 +102,7 @@
 // provided for back compatibility:
 int fl_draw_symbol(const char *label,int x,int y,int w,int h,Fl_Color col) {  
   const char *p = label;
-  if (*p++ != '@') return 0;
+  if (*p++ != FL_SYMBOL_CHAR) return 0;
   fl_init_symbols();
   int equalscale = 0;
   if (*p == '#') {equalscale = 1; p++;}
Index: src/Fl_Text_Display.cxx
===================================================================
--- src/Fl_Text_Display.cxx	(revision 13010)
+++ src/Fl_Text_Display.cxx	(working copy)
@@ -2246,7 +2246,7 @@
     else background = fl_color_average(color(), selection_color(), 0.6f);
     foreground = fl_contrast(textcolor(), background);
   } else {
-    foreground = textcolor();
+    foreground = active_r() ? textcolor() : fl_inactive(textcolor());
     background = color();
   }
 
Index: src/fl_utf8.cxx
===================================================================
--- src/fl_utf8.cxx	(revision 13010)
+++ src/fl_utf8.cxx	(working copy)
@@ -60,7 +60,76 @@
   return table[ucs];
 }
 
+
 /**
+  Find the leading character of a utf8 sequence based on
+  \e u8c in \e u8s_start with \e chars_avail available
+
+  \param u8c char position in string (may be in sequence)
+  \param u8s_start the string u8c is within
+  \param chars_avail number of chars available in u8s_start
+  \return pointer to start of a character
+*/
+const char *fl_utf8_find_leading_char(const char *u8c, const char *u8s_start, int chars_avail)
+{
+  const char *u8c_org = u8c;
+
+  while (u8c > u8s_start && fl_utf8_is_continuation_char(*u8c)) {
+    u8c--;
+  }
+
+  if (u8c != u8c_org && fl_utf8_is_leading_char(*u8c)) {
+    // check if valid sequence
+    if (fl_utf8len_real(u8c, (int) ((u8s_start + chars_avail) - u8c))>1) {
+      // return start of utf8 seq
+      return u8c;
+    }
+  }
+
+  // return original location
+  return ( u8c_org );
+}
+
+/**
+  Returns the byte length of the UTF-8 sequence -1 if not valid.
+*/
+int fl_utf8len_real(const char *str, int chars_avail)
+{
+  char c=*str;
+  if (!(c & 0x80)) return 1;
+
+  int utf8chlen;
+  if (c & 0x40) {
+    if (c & 0x20) {
+      if (c & 0x10) {
+        if (c & 0x08) {
+          if (c & 0x04) {
+            utf8chlen = 6;
+          }
+          else utf8chlen = 5;
+        }
+        else utf8chlen = 4;
+      }
+      else utf8chlen = 3;
+    }
+    else utf8chlen = 2;
+    if (utf8chlen <= chars_avail) {
+      const char *p=str;
+      for (int i = 1; i < utf8chlen; i++) {
+        p++;
+        if (((unsigned char)(*p) & 0xC0)!=0x80) {
+          return -1;
+        }
+      }
+      return utf8chlen;
+    }
+  }
+  return -1;
+}
+
+
+
+/**
   Returns the byte length of the UTF-8 sequence with first byte \p c,
   or -1 if \p c is not valid.
 
@@ -130,7 +199,7 @@
   int i = 0;
   int nbc = 0;
   while (i < len) {
-    int cl = fl_utf8len((buf+i)[0]);
+    int cl = fl_utf8len_real((const char*)(buf+i), len - i);
     if (cl < 1) cl = 1;
     nbc++;
     i += cl;
Index: src/Fl_Widget.cxx
===================================================================
--- src/Fl_Widget.cxx	(revision 13010)
+++ src/Fl_Widget.cxx	(working copy)
@@ -136,7 +136,14 @@
     // Make sure fl_graphics_driver is initialized. Important if we are called by a static initializer.
     Fl_Display_Device::display_device();
   }
+
+  // handle application option
+  if (L && Fl::copy_labels()) {
+    if ((label_.value=strdup(L))!=NULL) {
+      set_flag(COPIED_LABEL);
 }
+  }
+}
 
 void Fl_Widget::resize(int X, int Y, int W, int H) {
   x_ = X; y_ = Y; w_ = W; h_ = H;
@@ -276,28 +283,46 @@
 
 
 void Fl_Widget::label(const char *a) {
+
+  // handle application option
+  if (Fl::copy_labels()) {
+    copy_label(a);
+    return;
+  }
+
+  void *freelabel=NULL;
   if (flags() & COPIED_LABEL) {
     // reassigning a copied label remains the same copied label
     if (label_.value == a)
       return;
-    free((void *)(label_.value));
+    freelabel=(void *)(label_.value);
     clear_flag(COPIED_LABEL);
   }
   label_.value=a;
+  // free old label if existed
+  free(freelabel);
   redraw_label();
 }
 
 
 void Fl_Widget::copy_label(const char *a) {
-  // reassigning a copied label remains the same copied label
-  if ((flags() & COPIED_LABEL) && (label_.value == a))
+  void *freelabel=NULL;
+  if (flags() & COPIED_LABEL) {
+  	if (a==label_.value) {
     return;
-  if (a) {
-    label(strdup(a));
+  	}
+    freelabel=(void *)(label_.value);
+  }
+  if (a && (label_.value=strdup(a))!=NULL) {
     set_flag(COPIED_LABEL);
   } else {
-    label(0);
+    clear_flag(COPIED_LABEL);
+    label_.value=(char *)0;
   }
+  // remove old label if existed
+  free(freelabel);
+
+  redraw_label();
 }
 
 /** Calls the widget callback function with arbitrary arguments.
Index: src/Fl_Window.cxx
===================================================================
--- src/Fl_Window.cxx	(revision 13010)
+++ src/Fl_Window.cxx	(working copy)
@@ -156,9 +156,18 @@
 
 /** Sets the window titlebar label to a copy of a character string */
 void Fl_Window::copy_label(const char *a) {
-  Fl_Widget::copy_label(a);
-  label(label(), iconlabel());	// platform dependent
+  // don't delete old label until new label established
+  void *freelabel=NULL;
+  if (flags() & COPIED_LABEL) {
+    freelabel=(void*) label();
 }
+  // create new label copy
+  if (a) a = strdup(a);
+  label(a, iconlabel());
+  set_flag(COPIED_LABEL);
+  // remove old label if it existed
+  free(freelabel);
+}
 
 void Fl_Window::iconlabel(const char *iname) {
   label(label(), iname);	// platform dependent
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 13010)
+++ src/Fl_x.cxx	(working copy)
@@ -216,7 +216,7 @@
   // we send FL_LEAVE only if the mouse did not enter some other window:
   if (!in_a_window) Fl::handle(FL_LEAVE, 0);
 #if CONSOLIDATE_MOTION
-  else if (send_motion == fl_xmousewin) {
+  else if (send_motion == fl_xmousewin && send_motion!=0) {
     send_motion = 0;
     Fl::handle(FL_MOVE, fl_xmousewin);
   }
@@ -1271,6 +1271,13 @@
   fl_xevent = &thisevent;
   Window xid = xevent.xany.window;
 
+#if 0
+if (xevent.type>=LASTEvent) {
+  printf("xevent %d occured\n", xevent.type);
+}
+else printf("xevent %s occured\n", debugtext[xevent.type]);
+#endif
+
   if (fl_xim_ic && xevent.type == DestroyNotify &&
         xid != fl_xim_win && !fl_find(xid))
   {
@@ -1937,6 +1944,9 @@
     break;
   
   case ButtonPress:
+#if 0
+printf("ButtonPress: %Xh  state: %Xh\n", xevent.xbutton.button , xevent.xbutton.state);
+#endif
     Fl::e_keysym = FL_Button + xevent.xbutton.button;
     set_event_xy(window);
     Fl::e_dx = Fl::e_dy = 0;
Index: src/Makefile
===================================================================
--- src/Makefile	(revision 13010)
+++ src/Makefile	(working copy)
@@ -31,6 +31,7 @@
 	Fl_Chart.cxx \
 	Fl_Check_Browser.cxx \
 	Fl_Check_Button.cxx \
+	Fl_Checkbox_Browser.cxx \
 	Fl_Choice.cxx \
 	Fl_Clock.cxx \
 	Fl_Color_Chooser.cxx \
Index: test/input.cxx
===================================================================
--- test/input.cxx	(revision 13010)
+++ test/input.cxx	(working copy)
@@ -98,20 +98,29 @@
   int y = 10;
   input[0] = new Fl_Input(70,y,300,30,"Normal:"); y += 35;
   input[0]->tooltip("Normal input field");
+  input[0]->unicode_input(1);
+  input[0]->unicode_single_byte(1);
   // input[0]->cursor_color(FL_SELECTION_COLOR);
   // input[0]->maximum_size(20);
   // input[0]->static_value("this is a testgarbage");
+
   input[1] = new Fl_Float_Input(70,y,300,30,"Float:"); y += 35;
   input[1]->tooltip("Input field for floating-point number (F1)");
   input[1]->shortcut(FL_F+1);
+  input[1]->unicode_input(1);
+
   input[2] = new Fl_Int_Input(70,y,300,30,"Int:"); y += 35;
   input[2]->tooltip("Input field for integer number (F2)");
   input[2]->shortcut(FL_F+2);
+
   input[3] = new Fl_Secret_Input(70,y,300,30,"&Secret:"); y += 35;
   input[3]->tooltip("Input field for password (Alt-S)");
+  input[3]->unicode_input(1);
+
   input[4] = new Fl_Multiline_Input(70,y,300,100,"&Multiline:"); y += 105;
   input[4]->tooltip("Input field for short text with newlines (Alt-M)");
   input[4]->wrap(1);
+  input[4]->unicode_input(1);
 
   for (int i = 0; i < 4; i++) {
     input[i]->when(0); input[i]->callback(cb);
